(* ===================================================================== *)
(* FILE          : channelScript.sml                                     *)
(* DESCRIPTION   : Theorems about channel.                               *)
(*                                                                       *)
(* AUTHOR        : (c) Ade Azurat                                        *)
(* DATE          : 01.08.23                                              *)
(* ===================================================================== *)

structure channelScript =
struct
 

open HolKernel Parse basicHol90Lib ;
(*
Num_conv Num_induct Let_conv
     Prim_rec Type_def_support ;
*)
infix THEN THENL ORELSE;

open listTheory ;

val _ = new_theory "channel";

val _ = bossLib.Hol_datatype `array = CHAN of 'a list=>'a list`;

val GET_BUFF_def = bossLib.Define`GET_BUFF (CHAN buf his) = buf`;
val GET_HIST_def = bossLib.Define`GET_HIST (CHAN buf his) = his`;

 
val _ = export_theory();

end;

