load "ExprBiNF"  ;
load "ExprPP" ;
load "ExprPara" ;
load "ExprLib" ;
load "exConst" ;
load "LabelRules" ;

val sc =
	let
	fun f (v,t,_,_) = (v, TypePara.parseInLine t)
	in 
	map f exConst.context
	end ;

fun p s = 
	let
	val e = ExprPara.parseInLine s
	val (e',_) = ExprLib.tiInfer sc e
	in
	e'
	end ;

installPP (ExprPP.ppExpr false) ;

open ExprBiNF ;
open ExprNF ;

val e1 = p "p /\\ q ==> T" ;
val e1' = ExprInterface.to_iExpr e1 ;
val e1'' = reduceNeg e1' ;
val e1_3 = reduceTrivCont e1'' ;
normalize e1 ;

open LabelRules ;

fun lr lab f = labelReductionRule lab f ;

val e2 = p "(SYSLAB.P1.idle \\/ SYSLAB.P1.end ==> (x>0)) /\\ (~SYSLAB.P1.idle \\/ SYSLAB.P2.idle ==> ~(x>0))" ; 