load "PLGAPara" ;
load "ExprPP" ;
load "PLGADD" ;
load "PLSEQDD" ;
load "PLGALib" ;
load "TypeDD" ;
open PLSEQDD ;
open PLGADD ;
open TypeDD ;

installPP (ExprPP.ppExpr false) ;
val p = PLGAPara.parse ;
open PLGALib ;
val labit = labelize ;
val ex1 = p "./testfile/sample0.plg" ;

load "exConst" ;

val sc0 =
	let
	fun f (v,t,_,_) = (v, TypePara.parseInLine t)
	in 
	map f exConst.context
	end ;

val ty_int = TyCons ("int",[])			;
val ty_bool = TyCons ("bool",[])		;
val ty_list_int = TyCons ("list", [ty_int])	;
val ty_chan_int = TyCons ("chan", [ty_int])	;

val sc =
	[("job", ty_list_int),
	 ("seqNumber", ty_bool),
	 ("numSendItems", ty_int),
	 ("toICC", ty_chan_int)			]
	@
	sc0					;

val tc = typeCheck				;

load "PLGARules"  	;
open PLGARules  	;

val ex2 = labit "P" (tc sc ex1) ;
val atomics    = spitAtomics sc ex2 ;
val labs_table 
	= 
	let
	fun add_pname (sl,al) = ("SYSLAB.P." ^ sl, al)
	in
	map add_pname (mk_label_tab ex2)
	end ;

load "ExprPara" ;
load "ExprLib" ;


installPP (ExprPP.ppExpr false) ;

(* This part should be encapsulated ---

val (P,_) = ExprLib.tiInfer sc (ExprPara.parseInLine "(SYSLAB.P.start ==> (x>0)) /\\ (SYSLAB.P.idle ==> ~(x>0))") ;
val (Q,_) = ExprLib.tiInfer sc (ExprPara.parseInLine "SYSLAB.P.ok \\/ (x=1)") ;
val J = P ;


val goals = unlessReductionRule labs_table atomics P Q ;

Information needed : 

 J P Q,...

source : from spc file.

*) 
(*
val spList = PLPCPara.parseS "./test/sampe0.spc";
*)