structure TypeDD  = struct	(* DD = Data Definition	    *)

(* ============================================================
(*DOC

<MODULE> TypeDD

<AUTHOR> underdarkPrime

<ADDRESS> underdarkPrime@yahoo.com

<DATE> July 2001

DOC*)
============================================================ *)

(* ============================================================
(*DOC

<ITEM> Type

<DESC>
<PRE>
datatype Type =
	  TyVar  of string
	| TyCons of string * Type list
</PRE>

Representation of a simple type expression language. TyVar a
represents a type variable a. TyCons (c,tys) represents a type
contructor c.

<EXAMPLE>

<OL>

<li> <pre>TyCons ("int",[])</pre> represents the type int. <p> </li>

<li> <pre>TyCons ("fun", [TyVar "a", TyCons ("int",[])])</pre>
     
      represents the type <tt>a->int<tt> <p>

</OL>

DOC*)
============================================================ *)

datatype Type =
	  TyVar  of string
	| TyCons of string * Type list


end

