load "ExprBiNF"  ;
load "ExprPP" ;
load "ExprPara" ;
load "ExprLib" ;
load "exConst" ;

val sc =
	let
	fun f (v,t,_,_) = (v, TypePara.parseInLine t)
	in 
	map f exConst.context
	end ;

fun p s = 
	let
	val e = ExprPara.parseInLine s
	val (e',_) = ExprLib.tiInfer sc e
	in
	e'
	end ;

installPP (ExprPP.ppExpr false) ;

open ExprBiNF ;

open ExprNF ;

val e1 = p "p /\\ q ==> T" ;
val e1' = ExprInterface.to_iExpr e1 ;
val e1'' = reduceNeg e1' ;
val e1_3 = reduceTrivCont e1'' ;
normalize e1 ;

val e2 = p "(r \\/ (y IN -{1,2,3}-) \\/ (x>0)) /\\ ((!x: x>0 : x=y) \\/ ~(x>0) \\/ (!x: x>0 : x=y))" ;

