load "ExprLib" ;
load "ExprPara" ;
load "TypePP" ;
load "ExprPP" ;
load "exConst" ;
load "ExprHol";

val p = ExprPara.parseInLine ;

installPP (ExprPP.ppExpr true) ;
installPP TypePP.ppType ;

val sc =
	let
	fun f (v,t,_,_) = (v, TypePara.parseInLine t)
	in 
	map f exConst.context
	end ;

val infer = ExprLib.tiInfer sc ; 

val tip = ExprLib.tiInfer sc o p ;

val itx = ExprLib.tiInferX ;

val hol = ExprHol.exprInHol; 

(*
load "ExprDD" ;
load "TypeDD" ;
open ExprDD ;
open TypeDD ;

(* tip "(x=0) ==> (x=T)" ; *)


val ex1 =
    Binary(("==>",
             TyCons("fun",
                    [TyCons("bool", []),
                     TyCons("fun",
                            [TyCons("bool", []), TyCons("bool", [])])])),
            Binary(("=",
                    TyCons("fun",
                           [TyVar "b",
                            TyCons("fun",
                                   [TyVar "b", TyCons("bool", [])])])),
                   Ident("x", TyVar "a"), Lit("0", TyCons("int", []))),
            Binary(("=",
                    TyCons("fun",
                           [TyVar "c",
                            TyCons("fun",
                                   [TyVar "c",
                                    TyCons("bool", [])])])),
                   Ident("x", TyVar "a"),
                   Lit("T", TyCons("bool", [])))) ;

val ex2 =
    Binary(("==>",
             TyCons("fun",
                    [TyCons("bool", []),
                     TyCons("fun",
                            [TyCons("bool", []), TyCons("bool", [])])])),
            Binary(("=",
                    TyCons("fun",
                           [TyVar "b",
                            TyCons("fun",
                                   [TyVar "b", TyCons("bool", [])])])),
                   Ident("x", TyVar "a"), Lit("0", TyCons("num", []))),
            Binary(("=",
                    TyCons("fun",
                           [TyVar "c",
                            TyCons("fun",
                                   [TyVar "c",
                                    TyCons("bool", [])])])),
                   Ident("x", TyVar "a"),
                   Ident("y", TyVar "d"))) ;

val t1 = ExprLib.tyPhaseOne sc ;

fun typeIt s =
	let
	val (n,e) = t1 (p s)
	val (_,subst,ty) = ExprLib.tiInfer0 n [] e
	in
	(ExprLib.tySpec subst e, TypeLib.tySubst subst ty)
	end ;
	
fun typeE s =
	let
	val (n,e) = t1  s
	val (_,subst,ty) = ExprLib.tiInfer0 n [] e
	in
	(ExprLib.tySpec subst e, TypeLib.tySubst subst ty)
	end ;
*)
