load "PLGAPara" ;
load "ExprPP" ;
load "PLGADD" ;
load "PLSEQDD" ;
load "PLGALib" ;
load "TypeDD" ;
open PLSEQDD ;
open PLGADD ;
open TypeDD ;

installPP (ExprPP.ppExpr false) ;
val p = PLGAPara.parse ;
open PLGALib ;
val labit = labelize ;
val ex1 = p "sample0.plg" ;

installPP (ExprPP.ppExpr true) ;
load "exConst" ;

val sc0 =
	let
	fun f (v,t,_,_) = (v, TypePara.parseInLine t)
	in 
	map f exConst.context
	end ;

val ty_int = TyCons ("int",[])			;
val ty_bool = TyCons ("bool",[])		;
val ty_list_int = TyCons ("list", [ty_int])	;
val ty_chan_int = TyCons ("chan", [ty_int])	;

val sc =
	[("job", ty_list_int),
	 ("seqNumber", ty_bool),
	 ("numSendItems", ty_int),
	 ("toICC", ty_chan_int)			]
	@
	sc0					;

val tc = typeCheck				;

